
Ruby - Bug #4308

Wrong Bignum calculation in some case.

01/24/2011 06:59 AM - shouichi (Shouichi Kamiya)

Status: Rejected   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 1.9.2p136 (2010-12-25 revision

30365) [x86_64-darwin10.5.0]

Backport:  

Description

=begin

I tried to calculate variance of an array but calculation returns wrong result

when numbers are big.The problem also happens in 1.8.7-p330.

I attached a file that recreates The problem.

=end

History

#1 - 01/24/2011 09:58 AM - naruse (Yui NARUSE)

- Status changed from Open to Rejected

=begin

It seems from floating point's accuracy.

In line 9, it uses to_f and the value exceeds its limit.

=end

#2 - 01/24/2011 09:12 PM - nobu (Nobuyoshi Nakada)

=begin

#!/usr/bin/env ruby

class Array

def sum

reduce(:+)

end

def var

empty? ? 0.0 : (map {|x| x ** 2}.sum * size - sum ** 2).fdiv(size ** 2)

end

end

All of these should clearly return 0.

p [1295218865, 1295218865, 1295218865, 1295218865, 1295218865].var

#=> 0.0

p [1295218865, 1295218865, 1295218865, 1295218865, 1295218865, 1295218865].var

#=> 0.0

p [1295218865, 1295218865, 1295218865, 1295218865, 1295218865, 1295218865, 1295218865].var

#=> 0.0

=end

Files

wrong_bignum_calc.rb 514 Bytes 01/24/2011 shouichi (Shouichi Kamiya)
